import { autocompletion as H, completionKeymap as j, closeBrackets as B, closeBracketsKeymap as I } from "@codemirror/autocomplete";
import { indentWithTab as O, insertNewline as K } from "@codemirror/commands";
import { css as L } from "@codemirror/lang-css";
import { html as R } from "@codemirror/lang-html";
import { json as V } from "@codemirror/lang-json";
import { yaml as A } from "@codemirror/lang-yaml";
import { syntaxHighlighting as z, defaultHighlightStyle as J, indentOnInput as P, bracketMatching as v } from "@codemirror/language";
import { linter as U } from "@codemirror/lint";
import { StateEffect as W } from "@codemirror/state";
import { EditorView as h, highlightSpecialChars as q, keymap as u, placeholder as D, lineNumbers as G } from "@codemirror/view";
import { ref as Q, watch as m, onBeforeUnmount as X, toValue as t, computed as Y } from "vue";
import { customTheme as Z } from "../themes/index.js";
import { variables as _ } from "./variables.js";
const d = (e) => "provider" in e && !!t(e.provider), $ = {
  key: "Mod-a",
  run: (e) => (e.dispatch({
    selection: { anchor: 0, head: e.state.doc.length },
    scrollIntoView: !1
  }), !0)
}, he = (e) => {
  const i = Q(null);
  m(
    e.codeMirrorRef,
    () => {
      var o;
      (o = i.value) == null || o.destroy(), s();
    },
    { immediate: !0 }
  ), X(() => {
    var o;
    return (o = i.value) == null ? void 0 : o.destroy();
  });
  function s() {
    if (e.codeMirrorRef.value) {
      const o = d(e) ? t(e.provider) : null, a = E({
        ...l.value,
        provider: o
      });
      i.value = new h({
        parent: e.codeMirrorRef.value,
        extensions: a
      }), d(e) || n(t(e.content));
    }
  }
  const l = Y(() => ({
    onChange: e.onChange,
    onBlur: e.onBlur,
    onFocus: e.onFocus,
    disableTabIndent: t(e.disableTabIndent),
    language: t(e.language),
    classes: t(e.classes),
    readOnly: t(e.readOnly),
    lineNumbers: t(e.lineNumbers),
    withVariables: t(e.withVariables),
    disableEnter: t(e.disableEnter),
    disableCloseBrackets: t(e.disableCloseBrackets),
    withoutTheme: t(e.withoutTheme),
    lint: t(e.lint),
    additionalExtensions: t(e.extensions),
    placeholder: t(e.placeholder)
  }));
  m(
    () => d(e) ? t(e.provider) : null,
    () => {
      var o;
      d(e) && ((o = i.value) == null || o.destroy(), s());
    }
  ), m(
    l,
    () => {
      if (i.value) {
        const o = d(e) ? t(e.provider) : null, a = E({
          ...l.value,
          provider: o
        });
        i.value.dispatch({
          effects: W.reconfigure.of(a)
        });
      } else
        return;
    },
    { immediate: !0 }
  );
  const n = (o = "") => {
    i.value && i.value.state.doc.toString() !== o && i.value.dispatch({
      changes: {
        from: 0,
        to: i.value.state.doc.length,
        insert: o
      },
      selection: {
        anchor: Math.min(
          i.value.state.selection.main.anchor,
          o.length
        )
      }
    });
  };
  return m(
    () => t(e.content),
    () => {
      d(e) || n(t(e.content));
    },
    { immediate: !0 }
  ), {
    /** Replaces the current content with the given value. */
    setCodeMirrorContent: n,
    /** Codemirror instance */
    codeMirror: i
  };
}, y = {
  html: R,
  json: V,
  yaml: A,
  css: L
};
function E({
  onChange: e,
  onBlur: i,
  onFocus: s,
  provider: l,
  language: n,
  classes: o = [],
  readOnly: a = !1,
  lineNumbers: k = !1,
  withVariables: x = !1,
  disableEnter: C = !1,
  disableCloseBrackets: M = !1,
  disableTabIndent: S = !1,
  withoutTheme: T = !1,
  lint: N = !1,
  additionalExtensions: w = [],
  placeholder: g
}) {
  const r = [
    q(),
    z(J, { fallback: !0 }),
    h.theme({
      ".cm-line": {
        lineHeight: "20px"
      },
      ".cm-gutterElement": {
        lineHeight: "20px"
      },
      ".cm-tooltip": {
        border: "1px solid #f5c6cb",
        fontSize: "12px"
      },
      ".cm-tooltip-lint": {
        backgroundColor: "#ffffff"
      },
      ".cm-diagnostic-error": {
        borderLeft: "0",
        color: "#dc1b19"
      }
    }),
    // Listen to updates
    h.updateListener.of((f) => {
      f.docChanged && (e == null || e(f.state.doc.toString()));
    }),
    h.domEventHandlers({
      blur: (f, c) => {
        i == null || i(c.state.doc.toString());
      },
      focus: (f, c) => {
        s == null || s(c.state.doc.toString());
      }
    }),
    // Add Classes
    h.editorAttributes.of({ class: o.join(" ") }),
    ...w
  ];
  if (l && r.push(l), T || r.push(Z), a ? r.push(h.editable.of(!1)) : (r.push(
    P(),
    v(),
    H(),
    u.of([...j, $]),
    v()
  ), M || r.push(B(), u.of([...I])), S ? r.push(
    u.of([
      {
        key: "Tab",
        run: () => !1,
        // Prevent default Tab behavior
        shift: () => !1
        // Prevent default Shift+Tab behavior
      }
    ])
  ) : r.push(u.of([O]))), g && r.push(D(g)), n && y[n] && r.push(y[n]()), N && n === "json") {
    const f = U((c) => {
      const p = [];
      try {
        JSON.parse(c.state.doc.toString());
      } catch (b) {
        b instanceof Error && p.push({
          from: 0,
          to: c.state.doc.length,
          severity: "error",
          message: b.message
        });
      }
      return p;
    });
    r.push(f);
  }
  return k && r.push(G()), x && r.push(_()), C ? r.push(
    u.of([
      {
        key: "Enter",
        run: () => !0
      },
      {
        key: "Ctrl-Enter",
        mac: "Cmd-Enter",
        run: () => !0
      },
      {
        key: "Shift-Enter",
        run: () => !0
      }
    ])
  ) : r.push(
    u.of([
      {
        key: "Enter",
        run: K
      }
    ])
  ), r;
}
export {
  he as useCodeMirror
};
